2010-04-07  Jb Evain  <jbevain@novell.com>

	* main.c: don't overwrite method_name.

2010-04-06  Miguel de Icaza  <miguel@novell.com>

	* main.c: Prevent a crash with broken assemblies.

2010-03-30  Raja R Harinath  <harinath@hurrynot.org>

	Clean up some whitespace in the output
	* main.c (pinvoke_flags_map): Add a few trailing spaces.
	* util.c (flags): Simplify.

	Make util.c:flags() stricter
	* get.c (field_flags_map): Add empty entries for
	HAS_FIELD_MARSHAL, HAS_DEFAULT and HAS_FIELD_RVA.
	* main.c (method_flags_map): Add empty entry for HAS_SECURITY.
	* util.c (flags): Remove known flags from 'code' in loop.  Any
	leftover flags are printed as "unknown-flag-xx".

	Prepare for util.c:flags() to be stricter
	* main.c (pinvoke_flags): Remove cset and cconv flags before
	passing onto flags().
	(method_flags): Likewise with access flags.
	* get.c (field_flags): Likewise.
	(get_method_impl_flags): Likewise, with code_type and managed_type
	flags.

	* get.c (managed_impl_flags): Add 'nooptimization' flag.

2010-03-12  Jb Evain  <jbevain@novell.com>

	* dump.c (dump_table_exported): dump the type flags as well.


Wed Feb 24 16:00:56 CET 2010 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: link to the new libmono version.

2010-02-10  Miguel de Icaza  <miguel@novell.com>

	* main.c (dis_method_list): Show method implementation flags as
	well when calling --method.

	get.c: Moved some code here from main.c so it could be reused by
	dump.c

2009-12-21  Rodrigo Kumpera  <kumpera@gmail.com>

	* get.c (get_type): Don't crash if the type is not found.

2009-08-18  Christian Hergert  <chris@dronelabs.com>

	* dis-cil.c:
	* main.c: Fix printf warnings.

2009-07-16  Raja R Harinath  <harinath@hurrynot.org>

	* get.c (get_type): Make robust to invalid types.

2009-07-16  Marek Habersack  <mhabersack@novell.com>

	* main.c: added new --presources option which prints manifest
	resource offsets and names.

	* monodis.1: added documentation of the --presources option.

2009-06-10  Jb Evain  <jbevain@novell.com>

	* main.c: add support for extern types. Fixes #511672.

2009-06-03  Jb Evain  <jbevain@novell.com>

	* main.c (dis_code): don't try to locate invalid entry points.

2009-06-03  Jb Evain  <jbevain@novell.com>

	* main.c (dis_type): espace namespaces.

2009-04-24  Rodrigo Kumpera  <kumpera@gmail.com>

	* get.c (dis_stringify_method_signature_full): Don't assert
	if no marshal info is found.

2009-04-16  Rodrigo Kumpera  <kumpera@gmail.com>

	* dump.c: Add dump_table_fieldrva.

	* dump.h: Same.

	* main.c: Add the option to dump the field rva table.

2009-04-09  Raja R Harinath  <harinath@hurrynot.org>

	* get.c: Use new MonoGenericParamInfo accessors.

2009-04-08  Raja R Harinath  <harinath@hurrynot.org>

	* get.c: Use new MonoGenericParam accessors.

2009-04-08  Raja R Harinath  <harinath@hurrynot.org>

	* get.c: Use MonoGenericContainer accessor to get the contained
	MonoGenericParam.

2009-03-12  Jb Evain  <jbevain@novell.com>

	* get.c (get_token): add support for METHOD_SPEC tokens.

2009-01-12  Jb Evain  <jbevain@novell.com>

	* main.c: update reference to METHOD_ATTRIBUTE_CHECK_ACCESS_ON_OVERRIDE
	with METHOD_ATTRIBUTE_STRICT.

2008-12-30  Marek Safar  <marek.safar@gmail.com>

	* main.c: Add METHOD_ATTRIBUTE_CHECK_ACCESS_ON_OVERRIDE.

2008-12-01  Rodrigo Kumpera  <kumpera@gmail.com>

	* main.c (get_uninitialized_data_type): Make crappy static analyzers happy.

2008-10-29 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* main.c: don't crash when the method is in an assembly that can't be
	loaded. Just prints the warnings now instead of 'segfaulting'.
	Bug #436989 fixed.

2008-10-29 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* main.c: when loading the image, use mono_assembly_load_from_full
	instead of mono_assembly_load_references so that monodis mimics the
	way the runtime loads assemblies in the real world.
	Bug #439404 fixed.

2008-06-05  Jb Evain  <jbevain@novell.com>

	* get.c (get_token): properly stringify tokens that
	are methoddefs.

2008-05-26  Zoltan Varga  <vargaz@gmail.com>

	* get.c: Use accessor functions for accessing method->generic_container.	

2008-04-15  Zoltan Varga  <vargaz@gmail.com>

	* main.c (disassemble_file): Do not use mono_assembly_open () to load an image,
	since it does not allow loading a different mscorlib. Fixes #379866.

2008-03-05  Ankit Jain  <jankit@novell.com>

	* dis-cil.c (disassemble_cil): For catch clause, emit stringified class
	with prefix.

2008-02-04  Zoltan Varga  <vargaz@gmail.com>

	* get.c (get_escaped_name): Escape the name if it begins with a dot. Fixes
	#358564.

2007-12-06  Jb Evain  <jbevain@novell.com>

	* main.c: fix regression #346283.

2007-11-20  Jb Evain  <jbevain@novell.com>

	* main.c: support for uninitialized .data.

2007-11-05  Jackson Harper  <jackson@ximian.com>

	* declsec.c (declsec_20_write_type): support for strings.

2007-10-02  Jb Evain  <jbevain@novell.com>

	* declsec.c (declsec_20_write_type): support for bools.

2007-09-22  Zoltan Varga  <vargaz@gmail.com>

	* main.c (dis_property_signature): Remove some calls to mono_metadata_free_type ().

	* get.c (get_type): Ditto.	

Mon Jul 16 19:45:42 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* get.c: mono_get_inflated_method () is obsolete, removed.

2007-06-15  Raja R Harinath  <rharinath@novell.com>

	* get.c (dis_stringify_object_with_class): Update to changes in
	MonoGenericClass.
	(dis_stringify_type): Likewise.

2007-06-05  Rodrigo Kumpera  <kumpera@gmail.com>

	* get.c: Support for variance related generics modifiers: <+T> and <-T>

2007-03-22  Jb Evain  <jbevain@gmail.com>

	* dump.c, dump.h, main.c: Implement dumping of Strings
	and UserStrings heap.

2007-03-13  Jonathan Chambers  <joncham@gmail.com>

	* monodis.vcproj: Move to msvc directory.
	
2007-03-13  Jonathan Chambers  <joncham@gmail.com>

	* monodis.vcproj: Begin Win64 port.
	
Fri Jan 26 12:30:22 CET 2007 Paolo Molaro <lupus@ximian.com>

	* get.c, dis-cil.c: warning fixes.

Wed Jan 17 17:26:08 CET 2007 Paolo Molaro <lupus@ximian.com>

	* main.c: if a file can't be loaded as an assembly, load it as a
	modules, so monodis can be used also for netmodules.

2007-01-04  Raja R Harinath  <rharinath@novell.com>

	* get.c (get_method_core): Pick generic container from the
	declaring method.

2006-12-27  Raja R Harinath  <rharinath@novell.com>

	Avoid MonoGenericContext
	* dis-cil.c, dump.c, get.c, get.h, main.c: Replace all instances
	of MonoGenericContext with MonoGenericContainer, except for calls
	to mono_class_get_full and mono_get_method_full.  Use a top-down
	pass to propagate the original argument type from 'dis_method_list'.

	* dis-cil.c, dump.c, get.c, get.h, main.c: Replace several
	instances of MonoGenericContext with MonoGenericContainer.
	Use a bottom-up pass to propagate the "demand" parameter type from
	metadata type parsing.

2006-11-09  Ankit Jain  <jankit@novell.com>

	* dump.c (dump_table_assemblyref): Dump Flags also.
	* main.c (assembly_ref_flags): New. Stringify AssemblyRef flags.
	(dis_directive_assemblyref): Emit flags also.
	(dis_directive_assembly): Likewise.

2006-10-06  Miguel de Icaza  <miguel@novell.com>

	* main.c (dis_directive_assembly): Fix the rendering of .locale to
	be a data dump.

2006-10-06  Zoltan Varga  <vargaz@gmail.com>

	* dump.c main.c: Applied patch from Jb. Allow dumping the PropertyPtr table.

2006-10-05  Zoltan Varga  <vargaz@gmail.com>

	* dump.c main.c: Allow dumping the *Ptr tables.

2006-09-12  Zoltan Varga  <vargaz@gmail.com>

	* declsec.c: Fix windows VC build.

2006-08-09  Alp Toker  <alp@atoker.com>

	* dis-cil.c:
	* dis-cil.h:
	* main.c:
	* monodis.1:
	* push-pop.h:
	* util.c: Typofix 'dissasemble' to 'disassemble'.

2006-06-27  Ankit Jain  <jankit@novell.com>

	* get.c (get_assemblyref): Escape name.
	(get_moduleref): Likewise.
	(get_module): Likewise.

2006-06-02  Ankit Jain  <jankit@novell.com>

	* get.c (dis_stringify_method_signature_full): Fix two memory leaks.

2006-06-02  Ankit Jain  <jankit@novell.com>

	* main.c (dis_method_list): Print only the method name in "{ // end
	of.."

2006-06-02  Ankit Jain  <jankit@novell.com>

	* get.c (get_typedef): Return NULL for <Module> type.
	(get_escaped_class_name): Likewise.
	(dis_stringify_object_with_class): Likewise.

	(dis_stringify_type): Return NULL if the type name is NULL.
	(get_escaped_name): Don't try to escape a NULL name.

	(get_fieldref_signature): Type name can be null.
	(get_field): Likewise.
	(get_method_core): Likewise.
	(get_methoddef): Likewise.
	
	* main.c (dis_method_list): Print correct message for global methods.
	(dis_globals): Don't print '<Module>' for global methods/fields.

2006-06-01  Ankit Jain  <jankit@novell.com>

	* declsec.c (dump_declsec_entry20): Fix a warning.

2006-05-28  Zoltan Varga  <vargaz@gmail.com>

	* declsec.c (dump_declsec_entry20): Fix a warning.

2006-05-26  Ankit Jain  <jankit@novell.com>

	Patch from Sebastien Pouliot.
	* declsec.h: New. 
	* declsec.c: New. Support for new declarative security attribute
	metadata format (2.0)
	* dump.c (dump_table_declsec): Support the new 2.0 format.
	* main.c (dump_declarative_security): Support the new 2.0 format.
	* Makefile.am : Add declsec.c & declsec.h .

2006-05-15  Ankit Jain  <jankit@novell.com>

	* dis-cil.c (disassemble_cil): Exception clauses can be unordered,
	handle that.

2006-05-11  Ankit Jain  <jankit@novell.com>

	* get.c (get_custom_mod): Fix printing of custom modifiers.
	(dis_stringify_type): Likewise.
	(get_field_signature): Likewise.
	(get_ret_type): Likewise.
	(get_param): Likewise.

2006-05-11  Ankit Jain  <jankit@novell.com>

	* get.c (dis_stringify_method_signature): Rename to .. 
	(dis_stringify_method_signature_full): .. this. Add 'with_marshal_info'
	param.
	* get.h (dis_stringify_method_signature_full): Add new function.
	* main.c (dis_property_methods): Update to use
	dis_stringify_method_signature_full.
	(dis_event_methods): Likewise.

2006-05-10  Ankit Jain  <jankit@novell.com>

	* get.c (init_key_table): Add keyword 'switch'.

2006-05-10  Ankit Jain  <jankit@novell.com>

	* get.c (init_key_table): Add keyword 'property'.

2006-03-15  Zoltan Varga  <vargaz@gmail.com>

	* main.c (typedef_flags): Decode TYPE_ATTRIBUTE_FORWARDER.

2006-02-21  Ankit Jain  <jankit@novell.com>

	* get.c (can_print_generic_param_name): Rename to ..
	(cant_print_generic_param_name): .. this, to match function name with behavior.

2006-02-21  Ankit Jain  <jankit@novell.com>

	* get.c (mono_generic_params_with_ambiguous_names): New.
	(generic_containers): New. Hashtable of all generic containers that have
	been checked for ambiguous params.
	(check_ambiguous_genparams): New. Walk a MonoGenericContainer
	and fill mono_generic_params_with_ambiguous_names table.
	(can_print_generic_param_name): New. Check whether a MonoGenericParam has
	ambiguous names.
	(dis_stringify_type): Use new is_ambiguous_generic_param to determine
	whether to print number or name for VAR/MVAR.

2006-02-18  Raja R Harinath  <harinath@gmail.com>

	* get.c (get_typespec): Don't use mono_type_create_from_typespec_full().
	Use get_type() instead.
	(get_type): Add 'is_def' parameter.
	(get_field_signature, get_ret_type, get_param): Update.
	* dump.c (dump_table_property): Likewise.
	* get.h (get_type): Update prototype.

2006-02-16  Raja R Harinath  <rharinath@novell.com>

	* get.c (get_typespec): Pass MonoGenericContainer to
	mono_type_create_from_typespec_full.
	(get_type): Likewise.
	* main.c (dis_code): Likewise.
	(dis_property_signature): Likewise.

2006-02-15  Ankit Jain  <jankit@novell.com>

	* get.c (get_array_shape): Use mono_metadata_decode_signed_value to get
	lower bounds.

2006-02-09  Ankit Jain  <jankit@novell.com>

	* get.c (stringify_array): New. Returns the stringified representation
	of an array.
	(dis_stringify_array): Use stringify_array.
	(get_array_shape): Likewise. Also, allow lo_bounds to be signed.

2006-02-03  Sebastien Pouliot  <sebastien@ximian.com>

	* get.c: Added #include <mono/utils/mono-compiler.h> so VS.NET
	can compile monodis.

2006-01-28  Ankit Jain  <jankit@novell.com>

	* get.c (get_method_core): Emit generic arity for a MemberRef.
	(get_method_override): Emit full sig only if its a generic type.

2006-01-27  Ankit Jain  <jankit@novell.com>

	* get.c (get_methodref_signature): Remove 'context' parameter.
	Update call sites.
	* get.h (get_methodref_signature): Update.
	* dump.c (dump_table_memberref): Update.

2006-01-26  Raja R Harinath  <harinath@gmail.com>

	* get.c (stringify_double): Simplify, and avoid 'E' too.

2006-01-26  Ankit Jain  <jankit@novell.com>

	* get.c (stringify_double): Remove trailing '.' if it has 'e'.

2006-01-25  Ankit Jain  <jankit@novell.com>

	* get.c (stringify_double): New. Fix printing of float/doubles to enable
	roundtripping.
	* get.h (stringify_double): Add new function.
	(get_constant): Use stringify_double.
	* dis-cil.c (disassemble_cil): Likewise.
	
2006-01-25  Ankit Jain  <jankit@novell.com>
	    Raja R Harinath  <rharinath@novell.com>

	* get.c (dis_stringify_type): For MVAR/VAR, print number if the generic param
	is in the mono_generic_params_with_ambiguous_names table.

2006-01-20  Raja R Harinath  <rharinath@novell.com>

	* main.c (monodis_assembly_load_hook): New.
	(monodis_assembly_search_hook): New.
	(main): Install them as hooks into the assembly loading core.

2006-01-19  Ankit Jain  <jankit@novell.com>

	* main.c (dis_type): Dump custom attributes for a type before doing the same
	for its type parameters.

2006-01-18  Ankit Jain  <jankit@novell.com>

	* main.c (typedef_flags): Change 'special-name' to 'specialname'.

2006-01-17  Ankit Jain  <jankit@novell.com>

	* get.c (get_method_override): Use '.override method' syntax if the class or
	or the method itself is generic.
	* main.c (dis_code): Emit '.override' only, 'method' gets handled by get_method_override.

2006-01-17  Ankit Jain  <jankit@novell.com>

	* get.c (init_key_table): Add keywords 'bestfit', 'charmaperror', 'off' & 'on'.

2006-01-16  Ankit Jain  <jankit@novell.com>

	* get.c (get_method_core): Handle a MemberRef with a TypeSpec parent.
	Inflate MonoMethod after getting it from mono_get_method_full.

2006-01-15  Ankit Jain  <jankit@novell.com>

	* get.c (get_method_override): Get full signature of the method.
	* main.c (dis_code): Emit ".override method" for full signature
	of the method.

2006-01-06  Ankit Jain  <jankit@novell.com>

	* get.c (get_generic_param): Generic param attributes can be any combination
	of .ctor, valuetype and class, emit correctly.

2006-01-03  Ankit Jain  <jankit@novell.com>

	* get.c (init_key_table): Add keywords uint8, uint16, uint32 and uint64.

2005-12-24  Jb Evain  <jbevain@gmail.com>

	* main.c (dis_property_signature): read the hasthis flag.

2005-12-13  Zoltan Varga  <vargaz@gmail.com>

	* get.c (get_constant): Use finite() instead of isnormal () since the
	latter is not available on solaris.

2005-11-23  Ankit Jain  <jankit@novell.com>

	* get.c (get_methodspec): Use mono_get_method_full so as to handle
	methodspecs that refer to generic methods in other assemblies.

2005-11-23  Ankit Jain  <jankit@novell.com>

	* dump.c (has_cattr_get_table): Handle GenericParam.
	* get.c (dis_get_custom_attrs): Likewise.
	* main.c (dump_cattrs_for_type_params): New. Dump custom attributes
	for type parameters.
	(dis_method_list): Call dump_cattrs_for_type_params.
	(dis_type): Likewise.

2005-11-17  Ankit Jain  <jankit@novell.com>

	* get.c (dis_stringify_type): Escape generic type parameter names.

2005-11-17  Ankit Jain  <jankit@novell.com>

	* get.c (str_escape): New. Escape a given list of characters.
	  (get_escaped_name): Escape ' and \ using str_escape, and 
	allow ` .

2005-11-10  Ankit Jain  <jankit@novell.com>

	* dump.c (dump_table_method): Load generic param constraints.
	* get.c (dis_stringify_method_signature): Likewise.
	* main.c (dis_method_list): Likewise.
	  (dis_type): Likewise.

2005-11-10  Ankit Jain  <jankit@novell.com>

	* get.c (init_key_table): Add keyword - uint.

2005-11-08  Ankit Jain  <jankit@novell.com>

	* dump.c (dump_table_method): Get the type/method context required for parsing
	  method signature and dis_stringify'ing it.

2005-11-08  Ankit Jain  <jankit@novell.com>

	* get.c (init_key_table): Add keywords - callconv and flags.

2005-10-28  Ankit Jain  <jankit@novell.com>

	* dis_stringify_method_signature: Add detail for 'returns:' in the comment.

2005-10-28  Ankit Jain  <jankit@novell.com>

	* tests: Add new directory for test cases.

2005-10-28  Ankit Jain  <jankit@novell.com>

	* get.c (dis_stringify_method_signature): Use context instead of container
	  as container can be NULL.

2005-10-20  Ankit Jain  <jankit@novell.com>

	* get.c (get_method_core): Use the parent context for get_methodspec
	  instead of the inflated method's context.
	  (get_methodspec): Get the context for the generic method.
	  Use parent_context for getting the method's type parameters. 

2005-10-20  Ankit Jain  <jankit@novell.com>

	* main.c (dis_method_list): Oops. Check method_context for null.

2005-10-19  Ankit Jain  <jankit@novell.com>

	* main.c (dis_method_list): Fix warning introduced by my last patch.

2005-10-19  Ankit Jain  <jankit@novell.com>

	* main.c (dis_method_list): Use 'method_context' instead of 'container' for 
	  mono_metadata_parse_method_signature_full.

2005-10-02  Zoltan Varga  <vargaz@freemail.hu>

	* get.h get.c main.c: Fix some warnings and bugs.

2005-09-20  Ankit Jain  <jankit@novell.com>

	* monodis.1: Update documentation for --output.

2005-09-20  Ankit Jain  <jankit@novell.com>

	* main.c (table_list): Add --mresources to the table.
	  (usage): Don't add "--mresources" explicitly for usage output.
	  (main): Remove explicit handling for --mresources.

2005-09-20  Ankit Jain  <jankit@novell.com>

	* main.c (main): Dump managed resources when --output is specified.

2005-09-08  Ankit Jain  <jankit@novell.com>

	* monodis.1: Document --customattr, --declsec, --forward-decls, --implmap,
	  --marshal, --methodimpl, --methodspec, --mresources, --nested, --standalonesig,
	  and --typespec.

2005-09-08  Ankit Jain  <jankit@novell.com>

	* main.c (dis_nt_header): New. Dump pe_stack_reserve if different from the
	  default value (0x100000).
	  (disassemble_file): Call dis_nt_header.

2005-09-06  Ankit Jain  <jankit@novell.com>

	* main.cs (dis_directive_assemblyref): Use the row id into the AssemblyRef
	  table instead of 1 for dump_cattrs.
	  Spotted by Harinath.

2005-09-05  Atsushi Enomoto  <atsushi@ximian.com>

	quick build fix.
	* get.cs : (dis_get_custom_attrs) added assembly reference support.
	* main.cs: (dis_directive_assemblyref) use MONO_TOKEN_ASSEMBLY_REF.

2005-09-05  Ankit Jain  <jankit@novell.com>

	* main.c (dis_directive_assemblyref): Dump custom attributes.

2005-08-29  Ankit Jain  <jankit@novell.com>

	* get.c (dis_stringify_marshal_spec): Add new case for MONO_NATIVE_CUSTOM.
	
2005-08-27  Ankit Jain  <jankit@novell.com>

	* get.c (init_key_table): Add keywords - ldelem, stelem, stloc, stobj,
	  stsfld, sub, sub.ovf, sub.ovf.un, unbox to the table.

2005-08-25  Ankit Jain  <jankit@novell.com>

	* get.c (get_encoded_user_string_or_bytearray): Add len param.
	  (get_constant): Pass len param to get_encoded_user_string_or_bytearray.
	* dis-cil.c (dissasemble_cil): Calculate len of the userstring and pass to
	  get_encoded_user_string_or_bytearray.
	* get.h (get_encoded_user_string_or_bytearray): Add len param.

2005-08-23  Ankit Jain  <jankit@novell.com>

	Fix #75186.
	* get.c (get_ret_type): Use '&' instead of '[out]' for return type.

2005-08-23  Ankit Jain  <jankit@novell.com>

	* get.c (get_encoded_user_string_or_bytearray): New. Print a string if possible
	  or else a bytearray from the US heap.
	  (get_encoded_user_string_bytearray): New. Print a bytearray from the US heap.
	  (get_constant): Use get_encoded_user_string_or_bytearray for MONO_TYPE_STRING.
	* get.h (get_encoded_user_string_or_bytearray): Add the new function. 
	* dis-cil.c (get_encoded_user_string): Move to get.c .
	  (disassemble_cil): Use get_encoded_user_string_or_bytearray instead of 
	  get_encoded_user_string.

2005-08-20  Ankit Jain  <jankit@novell.com>

	* dis-cil.c (dissasemble_cil): Specify precision to enable
	  roundtripping of floats.
	* get.c (get_constant): Likewise.  

2005-08-13  Jb Evain  <jbevain@gmail.com>

	* get.c (get_token): handle the case when
	  the token is a member ref pointing to a method.

2005-08-12  Ankit Jain  <jankit@novell.com>

	* get.c (init_key_table): Add "xor" to the table.

2005-08-12  Jb Evain  <jbevain@gmail.com>

	* get.c (dis_stringify_method_signature): handle case when a method
	  has parameters but no corresponding Param row.
	  Patch forged with Ankit.

2005-08-12  Ankit Jain <jankit@novell.com>

	* get.c (dis_stringify_variant_type): New. Stringify MonoMarshalVariant.
	  (dis_stringify_marshal_spec): Add new case for MONO_NATIVE_SAFEARRAY. 

2005-08-11  Ankit Jain <jankit@novell.com>

	* get.c (element_type_map): Use "typedref" instead of "TypedByRef" for
	  MONO_TYPE_TYPEDBYREF.
	  (get_ret_type): Use "typedref" instead of "typedbyref".
	  (get_param): Likewise.
	  
Wed Aug 10 17:15:52 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* dump.c: dump the marshal signature blob on --marshal.

2005-08-04  Ankit Jain <jankit@novell.com>

	* main.c (dis_directive_moduleref): Always escape module ref names.

2005-08-03  Ankit Jain <jankit@novell.com>

	* main.c (call_conv_map): Oops. Add a sentinel entry (-1, NULL).

2005-08-03  Ankit Jain <jankit@novell.com>

	* main.c (call_conv_map): Map call conv value of 0 to "".

2005-08-02  Ankit Jain <jankit@novell.com>

	* main.c (dis_directive_moduleref): Escape module ref names.

2005-08-01  Ankit Jain <jankit@novell.com>

	* get.c (field_flags_map): Use C comments instead of C#.

2005-08-01  Ankit Jain <jankit@novell.com>

	* get.c (dis_stringify_marshal_spec): Include "marshal (..)" as part of the
	  returned string. And fix memory leak.
	  (dis_stringify_method_signature): Fix usage of dis_stringify_marshal_spec
	  accordingly.
	* main.c (dis_field_list): Fix usage of dis_stringify_marshal_spec. Cleanup
	  output of spaces.

2005-08-01  Ankit Jain <jankit@novell.com>

	* get.c (dis_stringify_marshal_spec): Make it non-static.
	* main.c (dis_field_list): Print marshal info for fields.
	
2005-07-29  Ankit Jain <jankit@novell.com>

	* get.c (get_constant): Fix printing of some constant types and make it consistent.

2005-07-28  Ankit Jain <jankit@novell.com>

	* get.c (dis_stringify_method_signature): Fix handling of marshal info for
	  method params. Also, handle possible gaps in the PARAM table.

2005-07-26  Zoltan Varga  <vargaz@freemail.hu>

	* main.c: Fix noinline->noinlining.

2005-05-26  Sebastien Pouliot  <sebastien@ximian.com>

	* monodis.vcproj: Project file for monodis.

2005-05-06  Zoltan Varga  <vargaz@freemail.hu>

	* main.c: Respect MONO_PATH when loading assemblies.

2005-04-23  Ankit Jain  <ankit@corewars.org>

	* get.c : Revert Atsushi's earlier patch. Its already been fixed with r43342.

2005-04-22  Atsushi Enomoto  <atsushi@ximian.com>

	* get.c : arraytype[,] should not be wrapped as 'arraytype[]'.

2005-04-20  Ankit Jain  <ankit@corewars.org>

	Fix #74521.
	* get.c (get_generic_param, get_method_core, get_methoddef): Dont use
	dis_stringify_object_with_class directly, use dis_stringify_type instead.

2005-04-20  Ankit Jain  <ankit@corewars.org>

	Fix #74657.
	* main.c (dis_field_list): Print default value if field has
	HAS_DEFAULT flag set.

2005-04-12  Ankit Jain  <ankit@corewars.org>
	
	Fix #74579.
	* main.c (dis_mresource): New. Dump embedded managed resources.
	(main, usage): Add '--mresources' argument.

2005-04-08  Ankit Jain  <radical@corewars.org>

	Fix #74374.
	* main.c (dis_type): Add 'is_nested' and 'forward' arguments.  If
	'is_nested', don't emit .namespace directive even if namespace is
	set.  If 'forward', print only types.
	(dis_types): Update to allow emitting forward declarations.
	(disassemble_file): Emit forward declarations if requested.
	(main, usage): Add '--forward-decls' argument.
	* get.c (get_typedef): When printing a nested type, don't include
	the namespace again, even if it is set.

2005-04-05  Zoltan Varga  <vargaz@freemail.hu>

	* dump.c dis-cil.c: Apply patches from freebsd ports collection.

2005-04-04  Zoltan Varga  <vargaz@freemail.hu>

	* get.c (get_constant): Applied patch from Ankit Jain (radical@gmail.com). Fixes #74367.

2005-03-29  Sebastien Pouliot  <sebastien@ximian.com>

	* dis-cil.c, dump.c: Add mono-compiler.h header to allow/ease 
	compilation with non-GCC compilers.

2005-03-04  Zoltan Varga  <vargaz@freemail.hu>

	* get.c (dis_stringify_marshal_spec): Fix this after recent runtime
	changes.

2005-03-01  Zoltan Varga  <vargaz@freemail.hu>

	* get.c: Output marshal info for parameters.

2005-02-13  Zoltan Varga  <vargaz@freemail.hu>

	* main.c: Output managed resources as well. Fixes #72033.

2005-02-01  Raja R Harinath  <rharinath@novell.com>

	* get.c (get_method_core): Use mono_method_signature (mh), not
	mh->signature.

2005-01-30  Zoltan Varga  <vargaz@freemail.hu>

	* get.c dis-cil.c dump.c: Fix 64 bit warnings.

2004-12-15 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* dump.c:
	* dis-cil.c: added isinf() for Solaris, that does not seem to have it.
	Fixes the build on Solaris.

2004-12-13  Miguel de Icaza  <miguel@ximian.com>

	* dis-cil.c, dump.c: Encode special constant +Inf, -Inf and NaN
	using hex constants instead of letting libc print the values.

2004-12-11  Martin Baulig  <martin@ximian.com>

	* get.c (get_typespec): Added `gboolean is_def' argument; removed
	the special case for MONO_TYPE_VAR/MVAR and pass `is_def' down to
	dis_stringify_type().
	(get_escaped_name): Allow `!'.	

2004-12-11  Martin Baulig  <martin@ximian.com>

	* get.c (get_token): Escape typedefs.

2004-12-11  Martin Baulig  <martin@ximian.com>

	* get.c (get_escaped_name): Correctly escape nested classes.

2004-12-11  Martin Baulig  <martin@ximian.com>

	* get.c (get_class_name): Renamed to get_escaped_class_name() and
	return an escaped class name; correctly escape nested classes.

2004-12-11  Martin Baulig  <martin@ximian.com>

	* get.c (dis_stringify_type): Added `gboolean is_def' argument; if
	false, display type parameters as numbers and not as names.
	(dis_stringify_object_with_class): Added `gboolean is_def' argument.
	(dis_stringify_array): Likewise.

2004-12-10  Martin Baulig  <martin@ximian.com>

	* get.c (init_key_table): Added `type' and `strict'.
	(get_generic_param): Also escape the type parameter names.
	Correctly handle multiple constraints.

2004-12-10  Martin Baulig  <martin@ximian.com>

	* get.c (get_fieldref_signature): Escape the field type and name
	here, too.

2004-12-10  Martin Baulig  <martin@ximian.com>

	Started to add generics support to monodis.

	* get.c (get_typedef_or_ref): Added `MonoGenericContext *'.
	(get_field_signature, get_field): Likewise.
	(get_methodref_signature, get_methodspec): Likewise.
        (get_token, get_token_type, get_typespec): Likewise.
        (get_method, get_method_type_param): Likewise.
	(get_method_override, dis_stringify_method_signature): Likewise.
	(get_type, get_ret_type, get_param): Likewise.

	* dis-cil.c (disasemble_cil): Added `MonoGenericContext *'.

2004-12-09  Martin Baulig  <martin@ximian.com>

	* get.c (get_generic_param): Take a `MonoGenericContainer *' and
	use it to print things instead of manually parsing the metadata.

	* main.c (dis_generic_param_and_constraints): Removed, use
	get_generic_param() instead.
	(dis_method_list): Added `MonoGenericContext *' argument.

Mon Dec 6 13:31:48 CET 2004 Paolo Molaro <lupus@ximian.com>

	* main.c: add a --filter=filename option to load a file
	with a list of types, fields, methods to disassemble.

2004-12-02  Miguel de Icaza  <miguel@ximian.com>

	* main.c: Rename compilercontrolled to privatescope

	* get.c (get_class_name): Correct implementation that correctly
	handles nested classes.

2004-11-26  Miguel de Icaza  <miguel@ximian.com>

	* main.c: Better implementation of the quote keyword, list all of
	the known keywords to ildasm here. 

	* get.c (dis_stringify_object_with_class): Take an argument
	`prefix' that controls whether the `class', `valuetype' labels are
	used.  This is needed for the catch clause that takes the type
	directly. 
	(get_method_core): Rename get_method to get_method_core, and allow
	for only part of the signature to be specified, so we can produce
	.override signatures correctly.
	(get_method_override): Pass false as the `fullsig' argument.

	(get_typedef): no longer quote the type, we quote in the call site
	elsewhere.   Avoids double quotes.
	
	* main.c (quote_keyword): Quote keywords.

Tue Nov 9 17:29:28 CET 2004 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c, get.c, get.h: update to exception clause structure changes.

2004-11-08  Ben Maurer  <bmaurer@ximian.com>

	* get.c, dump.c: warning free.

2004-10-21  Jackson Harper  <jackson@ximian.com>

	* get.c: Escape typedef names.

2004-10-19    <vargaz@freemail.hu>

	* main.c: Applied patch from Alexandre Rocha Lima e Marcondes  (alexandremarcondes@psl-pr.softwarelivre.org). Really fix 2.95 build.

2004-10-04  Sebastien Pouliot  <sebastien@ximian.com>

	* dump.c: Added new "internal" security actions for non-CAS demands:
	NonCasDemand, NonCasLinkDemand and NonCasInheritance.
	* main.c: Added new "internal" security actions for non-CAS demands:
	noncasdemand, noncaslinkdemand and noncasinheritance.

2004-09-24  Zoltan Varga  <vargaz@freemail.hu>

	* main.c: Add support for pinvoke flags BestFit and 
	ThrowOnUnmappableChar.

2004-09-23  Miguel de Icaza  <miguel@ximian.com>

	* main.c (dis_directive_assemblyref): Dump the locale and public
	key tokens 

	* get.c (dis_stringify_object_with_class): Escape assembly name. 

	* main.c (dis_directive_assemblyref): Escape assembly name

2004-09-21  Martin Baulig  <martin@ximian.com>

	* main.c (main): If just a single assembly was specified, use the
	runtime version it requires.

2004-09-16  Sebastien Pouliot  <sebastien@ximian.com>

	* dump.c: Added new security actions added in 2.0: LinkDemandChoice,
	InheritanceDemandChoice and DemandChoice.
	* main.c: Added ".permissionset" to output IL. Removed "hassecurity"
	as MS ilasm can't compile it.

2004-09-16  Zoltan Varga  <vargaz@freemail.hu>

	* get.c (get_token): Add support for memberrefs.

2004-09-06  Zoltan Varga  <vargaz@freemail.hu>

	* main.c: Fix build && warnings.

2004-09-05  Jambunathan K  <kjambunathan@novell.com>
	* main.c (dump_cattrs_list): Newly carved out of dump_cattrs.
	
	Renamed cattrs_for_method() to more meaningful
	dump_cattrs_for_method_params()
	
	(dump_cattrs_for_method_params): Fixed so that ".param[]" gets
	dumped only when necessary. i.e., when a method parameter has
	either a default value and/or when it has a custom attribute.

2004-09-06  Zoltan Varga  <vargaz@freemail.hu>

	* get.c: Fix printing of unmanaged calling conventions.
	(get_constant): Fix warning.

2004-08-28  Jambunathan K  <kjambunathan@novell.com>
	* main.c: modified cattrs_for_method so that
	  emitting of ".param[] = ..." is complete.
	
	* get.c: Modified get_constant() so that
	  1. MONO_TYPE_CHAR now handles unicode characters
	  2. MONO_TYPE_I8 now emits int64(...)
	  3. MONO_TYPE_STRING emits a bytearray()

2004-08-18  Jambunathan K  <kjambunathan@novell.com>
	* get.c: Changed dis_stringify_param to emit [opt] for parameters
	  that are marked as Optional.

	* dump.c: Fixed dump_table_constant so that the parent field's
	  description is correctly displayed.

2004-08-08  Zoltan Varga  <vargaz@freemail.hu>

	* get.c (get_typespec): Append '*' to pointer types. Fixes #62331.

2004-08-03  Martin Baulig  <martin@ximian.com>

	* dump.c (method_dor_to_token): Moved to get.c and made public.

	* get.c (get_method_override): New public function.

	* main.c (dis_code): Added `.override' for override methods.

2004-08-02  Martin Baulig  <martin@ximian.com>

	* get.c (dis_stringify_object_with_class): Include our generic
	arguments in the method's class name.

	* main.c (dis_generic_param_and_constraints): Use the new
	constraints syntax.

2004-08-02  Martin Baulig  <martin@ximian.com>

	* dump.c (dump_stream_blob): Format this nicely.
	(dump_table_standalonesig): New public function.

	* main.c (dis_locals): If --show-tokens was requested, print the
	standalone signature token.
	(table_list): Added "--standalonesig".

2004-07-09  Jackson Harper  <jackson@ximian.com>

	* get.c: Make "class" the default so only valuetypes get the
	"valuetype" modifier. Otherwise object, string, int,... will get
	it.
	
2004-07-08  Jackson Harper  <jackson@ximian.com>

	* main.c: Spaces after visibility types.
	
2004-07-06  Jackson Harper  <jackson@ximian.com>

	* get.c: Add float cast for outputing floats. Patch by Steve Brown.
	
2004-06-25  Jackson Harper  <jackson@ximian.com>

	* get.c: Add a few more keywords to be escaped.
	* main.c: MS's ildasm writes '// end of class' not '// end of
	type'. The python.net tool searches for this string.
	
2004-06-24  David Waite  <mass@akuma.org>

	* dump.c: change to C90-style comments from C99/C++-style
	
2004-06-23  Raja R Harinath  <rharinath@novell.com>

	* main.c (dis_event_signature): Decode and print event_flags.

2004-06-20  Jackson Harper  <jackson@ximian.com>

	* dis-cil.c: Handle switch statements with no labels.
	
2004-06-19  Jackson Harper  <jackson@ximian.com>

	* dump.c/h: New function to dump the contents of the blob
	stream. I found it useful for debugging so I will share.
	* main.c: Add --blob switch to dump the blob stream.
	* monodis.1: Document --blob
	
2004-06-19  Jackson Harper  <jackson@ximian.com>

	* get.c/h: New function to stringify function pointers.
	
2004-06-19  Jackson Harper  <jackson@ximian.com>

	* get.c: Fix name escaping so we dont escape everything in the
	world anymore.
	
2004-06-11  Martin Baulig  <martin@ximian.com>

	* get.c (get_methodref_signature): Include "vararg " in the
	signature of a varargs method.

2004-06-11  Martin Baulig  <martin@ximian.com>

	* get.c (get_methodref_signature): If we're a varargs method,
	print "..." for the sentinel followed by the actual types.

2004-06-08  Martin Baulig  <martin@ximian.com>

	* dump.c (dump_table_memberref): Added support for MethodDef
	parents.	

2004-05-06  Bernie Solomon  <bernard@ugsolutions.com>

	* dump.c:
	* get.c:
	* main.c:
	* util.c:
	* util.h: rename map_t dis_map_t to avoid AIX symbol clash

2004-04-01  Martin Baulig  <martin@ximian.com>

	* dump.c (dump_table_memberref): Added support for TypeDef's.

2004-03-29  Jackson Harper  <jackson@ximian.com>

	* main.c: Handle pinvoke info where there is not an impl_map
	entry.
	
2004-03-27  Vladimir Vukicevic  <vladimir@pobox.com>

       * get.c (get_constant): output bool consts as bool(true) or
       bool(false)  (to be same as ildasm, also what mono and ms
       ilasm expect)

2004-01-31  Martin Baulig  <martin@ximian.com>

	* get.c (get_methodspec): It's a methoddef or ref token.

2004-01-26  Martin Baulig  <martin@ximian.com>

	* main.cs (--show-tokens): New command line argument to show
	type tokens in the disassembly.

	* get.c (get_typedef, get_typespec, get_typeref): If
	`show_tokens', include the token in the type name.
	(get_type): Do some type parsing here and include the token in the
	returned type name if requested.
	(get_method): Include tokens if requested.

2004-01-17  Zoltan Varga  <vargaz@freemail.hu>

	* main.c get.c: Add support for dumping the custom attributes of
	modules.

2004-01-09  Jackson Harper  <jackson@ximian.com>

	* monodis.1: Add --show-method-tokens switch
	* get.c: When stringifying methods show the method token if the
	show-method-tokens flag is set.
	* get.h: Add show_method_tokens flag
	* main.c: Add --show-method-tokens switch
	
2004-01-09  Jackson Harper  <jackson@ximian.com>

	* monodis.1: Add typespec switch
	
2004-01-08  Jackson Harper  <jackson@ximian.com>

	* main.c: Add switch to dump typespec table.
	* dump.c/dump.h: Add function for dumping typespec table.
	
2003-12-19  Zoltan Varga  <vargaz@freemail.hu>

	* dump.c (dump_table_exported): Fix output.

2003-12-08  Jackson Harper <jackson@ximian.com>

	* main.cs: escape module names.
	
2003-12-03  Zoltan Varga  <vargaz@freemail.hu>

	* main.c (dis_field_list): Update after changes to 
	mono_metadata_get_constant_index ().

2003-11-26  Zoltan Varga  <vargaz@freemail.hu>

	* dump.c dump.h main.c: Added support for dumping the ImplMap table
	(--implmap).

	* main.c (dis_method_list): Avoid disassembling native code.

2003-11-19  Zoltan Varga  <vargaz@freemail.hu>

	* get.c (dis_stringify_modifiers): Fix display of modreq and modopt.

Thu Nov 13 16:12:09 CET 2003 Paolo Molaro <lupus@ximian.com>

	* util.h, dump.c: get rid of ugly CSIZE macro.

2003-11-01  Zoltan Varga  <vargaz@freemail.hu>

	* main.c: Add disassembly of module, moduleref and file tables.

	* get.h get.c: Add support for modulerefs.

	* dump.c: Avoid crash on empty assembly table.

2003-10-22 Jackson Harper <jackson@ximian.com>

	* main.c: Use escaped names for method, and type names. Initialize
	the name table.
	* main.c (visibility_map): Fix typo, should be nested family not
	family
	* main.c (dis_data): Use uppercase hex to avoid name conflicts.
	* get.c/get.h: New method to get an escaped name. This method will
	take a name and escape it if it is an ilasm keyword, or uses a non
	id char. Use escaped names for type, method, field, and parameter names.
	* get.c (get_typespec): A typespec can be used for anything, so we
	need to handle all types not just modified types.
	* get.c (dis_stringify_object_with_class): Handle nested classes
	* get.c (get_token): Add field keyword to field tokens.
	
2003-10-21 Jackson Harper <jackson@ximian.com>

	* get.c (get_fieldref_signature): Use MONO_MEMBERREF_SIGNATURE in
	the member ref table.
	
2003-10-21  Martin Baulig  <martin@ximian.com>

	* get.c (get_typespec): Add MONO_TYPE_VAR and MONO_TYPE_MVAR.

2003-10-18 Jackson Harper <jackson@ximian.com>

	* dis-cil.c (get_encoded_user_string): use g_strescape instead of
	escaping manually.
	* util.c (hex_dump): Use uppercase hex so there are no conflicts
	with ilasm keywords ie cf
	
2003-10-17 Jackson Harper <jackson@ximian.com>

	* dis-cil.c (get_encoded_user_string): Escape user strings when
	loading. ie ""quote"" should be "\"quote\"".
	* dis-cil.c (dissasemble_cil): Write SEH debug info into a comment
	block. Combine SEH blocks that have the same offset and length,
	this prevents creating invalid SEH blocks. 
	
2003-10-15  Zoltan Varga  <vargaz@freemail.hu>

	* get.c (get_ret_type): Remove needless warning message.

2003-10-13 Jackson Harper <jackson@ximian.com>

	* get.c: stringify nested types properly ie Outer/Inner.
	
2003-10-10 Jackson Harper <jackson@ximian.com>

	* dump.c: When dumping methodspecs dump the full methodspec with
	signature, and dump the signature.
	
2003-10-10 Jackson Harper <jackson@ximian.com>

	* get.c/get.h: Add methods to get stringified methodspecs and
	method type parameters. 
	
2003-10-09 Jackson Harper <jackson@ximian.com>

	* main.c/get.c: Remove magic numbers, use constants.
	
2003-10-08 Jackson Harper <jackson@ximian.com>

	* main.c (dis_genericparam): renamed to
	dis_generic_param_and_constraints, allow a table type to be passed
	to the method so this could be used with generic methods (It is
	not though).
	* get.c/get.h (get_generic_param): method to stringify generic
	type and method parameters.
	* get.c (dis_stringify_method_signature): Add generic parameters.
	
2003-10-08 Jackson Harper <jackson@ximian.com>

	* main.c (dis_type): NULL cnst_block so we dont explode on
	interfaces.
	* main.c (dis_genericparam): oops, fix off-by-one error.
	
2003-10-08 Jackson Harper <jackson@ximian.com>

	* get.c/get.h add method to get a methoddef from an index, simplify
	get_typd_or_methdef, use new get_methoddef to get the method
	because we have a method index not a method token.
	
2003-10-07 Jackson Harper <jackson@ximian.com>

	* main.c: When dis. generic parameters the TypeOrMethodDef token
	only needs to be shifted 1 bit. Added dis of generic constraints.
	* get.c/get.h: New method for getting a TypeOrMethodDef token
	* dump.c: When dumping generic parameters and generic constraints
	output readable names instead of just tokens.
	
2003-10-01 Jackson Harper <jackson@latitudegeo.com>
	
	* main.c: Fix visibility level names, when outputing pinvoke info
	quote the module and method names, properties have specialname,
	and rtspecialname flags	(nothing else), dis global methods and
	fields FIXME: indentation issues.
	* get.h: declare get_fieldref_signature
	* get.c: Fix unsigned ints (not uint), single quote argument names
	(this is kinda a hack, ildasm will only single quote arg names
	that are ilasm keywords), remove fixme, we know what typedbyref
	means, output fieldref signatures instead of their token value.
	
2003-09-19 Jackson Harper <jackson@latitudegeo.com>

	* dis-cil.c: Output fault blocks, and filter blocks. If in a
	filter block outptut 0xDC as endfilter if in a fault output as
	endfault.
	
2003-08-22  Zoltan Varga  <vargaz@freemail.hu>

	* main.c (dis_event_list): Same for event methods.

	* get.c (dis_stringify_method_signature): New argument specifying
	whenever to return a fully qualified method name.
	* dump.c main.c: Updated to work with the new function.

	* main.c (dis_property_methods): Print fully qualified method names 
	for property methods. Fixes #46221.

2003-07-22 Jackson Harper <jackson@latitudegeo.com>

	* main.c: Dissasemble generic type parameters for type
	definitions. TODO: Sort type parameters by index, and
	auto-generate names for parameters that have no name.
	
Fri Jul 18 13:12:38 CEST 2003 Paolo Molaro <lupus@ximian.com>

	* get.c: updates for array type representation changes.

2003-06-16 Jackson Harper <jackson@latitudegeo.com>

	* get.c: Fix modopt and modreq
		
Thu May 29 12:21:47 CEST 2003 Paolo Molaro <lupus@ximian.com>

	* dump.c, get.c: misc fixes.

Wed May 7 16:50:00 CEST 2003 Paolo Molaro <lupus@ximian.com>

	* main.c: output custom attributes for method parameters.

Wed May 7 16:24:43 CEST 2003 Paolo Molaro <lupus@ximian.com>

	* main.c: output nested types inside their nesting class.

2003-04-12  Zoltan Varga  <vargaz@freemail.hu>

	* get.c (dis_stringify_modifiers): Print a space between custom modifers.
	* get.c (get_custom_mod): Handle multiple custom modifiers aka bug #30812.
	* main.c: Print klass name at the end of each method to make it easier
	to find a given method.

2003-03-31  Miguel de Icaza  <miguel@ximian.com>

	* main.c: Sorted command line options table by name.

	* dump.c: Add support for dumping the new generic tables. 

	* monodis.1: Update man page.
	
2003-03-09 Jackson Harper <jackson@latitudegeo.com>

	* main.c: Ouput implements clause as a comma seperated list.

Thu Feb  6 02:43:23 PST 2003 Piers Haken <piersh@friskit.com>

	* dump.c: more warning cleanups

Mon Jan 27 17:16:50 CET 2003 Paolo Molaro <lupus@ximian.com>

	* get.c: decode also the size info in get_marshal_info()
	for ByValStr and ByValArray.

Tue Sep 24 11:48:53 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c: use mono_type_size () to get the size of
	a blob of data for a type (Zoltan Varga spotted the bug).

2002-09-22  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* get.c: closes bug #30814. Thanks to Zoltan Varga.

Mon Sep 16 18:49:55 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c, get.c, dump.c: updates for changes in libmetadata.

Fri Sep 13 15:39:41 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c: dump public key.
	* get.c, util.h, util.c: prettyfy data dumps.

2002-08-28  Dick Porter  <dick@ximian.com>

	* Makefile.am: Export HOST_CC for w32 builds

Tue Aug 6 12:40:09 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c: use mono_image_get_entry_point ().

Fri Jul 26 11:41:32 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c, dump.h, dump.c: output hash value in File table.
	Add dumper function for DeclSecurity table.

Fri Jul 19 14:20:10 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c: handle null parent.

2002-07-02  Martin Baulig  <martin@gnome.org>

	* get.c (dis_stringify_object_with_class): New static function to
	stringify an object when we already have its class.
	(dis_stringify_object): Get the class and call dis_stringify_object().
	(get_method): Call dis_stringify_object_with_class() since we already
	have the object's class.

Thu Jun 20 11:50:38 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c, dump.c, dump.h: code to dump the MethodImpl table.

Mon Jun 17 17:31:19 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* get.h, get.c: get_marshal_info() to get a marshal descriptor.
	* main.c, dump.h, dump.c: added code to dump the FieldMarshl table.

Tue Jun 11 14:11:12 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* get.c: handle modulerefs.
	* main.c: fix --mscorlib argument handling.

Fri Jun 7 19:39:43 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* get.c: handle typerefs of nested types. Don't print "."
	with an empty namespace.

Sat Jun 1 13:57:17 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c: print byte values correctly.

2002-05-20  Martin Baulig  <martin@gnome.org>

	* main.c: Added `--output=FILENAME' command line option.

	* monodis.1: Documented it here.

Thu May 16 17:21:07 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c, dump,c, get.h, get.c: diassemble custom attributes.

Wed May 15 16:02:56 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c: output field RVA data.

Fri May 10 21:00:52 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c: print field offset info if needed.

Wed May 1 17:07:56 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* dump.c, dump.h, main.c: dump ExportedTypes table.
	* get.c: fix get_module (), remove magic numbers.
	* monodis.1: update manpage (hi miguel!:)

Mon Apr 29 12:12:35 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* dump.c, dump.h, main.c: support for dumping the manifest resource table.

Mon Apr 15 11:35:05 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* dump.c, dump.h, get.c, get.h, main.c: support for dumping the
	module table and guid values.

Mon Apr 8 17:15:04 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* main.c: removed unneeded runtime invoke support.

Thu Mar 28 16:52:11 CET 2002 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c, dump.c, get.c, main.c, util.h: spring warning cleanup.

Thu Mar 28 11:29:58 CET 2002 Paolo Molaro <lupus@ximian.com>

	* util.c: when an invalid flags combination is seen,
	return the string "invalid-flags", so disassembly can continue.

Tue Mar 19 18:15:29 CET 2002 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c: use unsigned for variables.

Sat Mar 16 19:13:57 CET 2002 Paolo Molaro <lupus@ximian.com>

	* dump.c: handle TypeSpec token in memberref table dump.

2002-03-08  Nick Drochak  <ndrochak@gol.com>

	* monodis.1: Add info about new parameter
	* main.c: Add flag to remember if user wants to us mscorlib for
	non-corilb assembly names
	* get.c(get_typedef): use mscorlib for assembly name only
	if user specifies it with a command line parameter. Default
	behavior is now to use actual assembly name.
 
Tue Mar 5 18:11:01 CET 2002 Paolo Molaro <lupus@ximian.com>

	* dump.c: print index of the methodsemantics table.
	* main.cs: print event information.

Wed Feb 20 22:10:48 CET 2002 Paolo Molaro <lupus@ximian.com>

	* dump.c: fix the fix and more complete custom attribute decoder.

Tue Feb 19 20:20:15 CET 2002 Paolo Molaro <lupus@ximian.com>

	* dump.c: the prolog is before each arg in the custom attribute blob.

Mon Feb 18 15:48:38 CET 2002 Paolo Molaro <lupus@ximian.com>

	* get.c: include last param.

Thu Feb 14 18:59:37 CET 2002 Paolo Molaro <lupus@ximian.com>

	* main.c: output pack and size info if needed.

2002-02-13  Dietmar Maurer  <dietmar@ximian.com>

	* *.c: s/MonoMetadata/MonoImage/ 

Tue Feb 12 14:33:53 CET 2002 Paolo Molaro <lupus@ximian.com>

	* dump.c: make all the indexes printed starting from 1.

Fri Feb 8 19:28:31 CET 2002 Paolo Molaro <lupus@ximian.com>

	* get.c: don't abort if a methodref is not found, usa alternative way
	to get the method name.

Fri Feb 8 12:29:41 CET 2002 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: correct linking order.
	* dis-cil.c: use opcode info from opcodes.h instead of a copy of the data.

Thu Jan 31 18:21:12 CET 2002 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c: reverse order when outputting start try blocks.

Mon Jan 14 17:00:23 CET 2002 Paolo Molaro <lupus@ximian.com>

	* dump.c: more info in method table dump.

Mon Dec 24 17:24:13 CET 2001 Paolo Molaro <lupus@ximian.com>

	* main.c, dump.h, dump.c: add dump_table_nestedclass().
	* dis-cil.c: output int64 as hex.

Tue Dec 18 18:48:00 CET 2001 Paolo Molaro <lupus@ximian.com>

	* main.c: use mono_metadata_methods_from_property() and
	mono_metadata_properties_from_typedef() from metadata instead of
	custom code.

Tue Nov 27 16:31:52 CET 2001 Paolo Molaro <lupus@ximian.com>

	* main.c: output a marker for method (used in debug support).

Mon Nov 19 11:32:28 CET 2001 Paolo Molaro <lupus@ximian.com>

	* main.c: remove arch_create_jit_trampoline().

Thu Nov 15 17:42:03 CET 2001 Paolo Molaro <lupus@ximian.com>

	* dump.c: decode more info in the constant table.
	* get.c: show literals the same way ildasm does.
	* main.c: decode literal values for fields.

Fri Nov 2 19:04:21 CET 2001 Paolo Molaro <lupus@ximian.com>

	* main.c, dump, dump.c: decode the customattr table.
	* dump.c: handle also field signature when dumping the memberref
	table.

2001-11-07  Miguel de Icaza  <miguel@ximian.com>

	* main.c (dis_property_methods): Added missing colon which avoided
	setting loc.t

2001-10-10  Dietmar Maurer  <dietmar@ximian.com>

	* main.c (arch_compile_method):  added to compute vtable entry

Mon Oct 8 16:13:55 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* get.c, get.h: MonoArray changed in MonoArrayType.
	* main.c: guard against calling bsearch with a NULL pointer
	(pointed out by Laurent Rioux, smoux).

Thu Oct 4 19:05:56 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c: fix printing of exception stuff.
	* dump.c: display some more info in the typedef table dump.
	* main.c: typo fix and method list fix.

2001-10-04  Dick Porter  <dick@ximian.com>

	* meta.h: include mono-endian.h not endian.h

2001-10-02  Dietmar Maurer  <dietmar@ximian.com>

	* get.c (get_method): always write namespace and class name.

2001-09-06  Miguel de Icaza  <miguel@ximian.com>

	* monodis.1: Update man page.

Tue Aug 28 15:54:45 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* main.c, dump.c, dump.h, get.c: added dump_table_interfaceimpl ().
	Output info about interfaces when disassembling a type. Many small
	changes to make the output correct assembler.

Mon Aug 27 20:13:49 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c, get.c: some endian fixes.
	* main.c: colon-separate version numbers. Print also namespace
	when outputting class information.

Fri Aug 24 16:10:12 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* get.c, main.c, get.h: updates for MonoParam merge in MonoType.

2001-08-24  Dietmar Maurer  <dietmar@ximian.com>

	* main.c (disassemble_file): use assembly_open instead of image_open

Wed Aug 22 16:22:22 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c: add a newline after branch instructions. Move
	end of exception handler code at the end.

Tue Aug 21 18:51:05 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c: correctly print the label for multi-byte opcodes.

Mon Aug 20 19:33:34 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* util.c: add a space when decoding multiple flags.
	* dump.c, dump.h, main.c: decode the property map and
	methodsemantics tables. Disassemble property information
	to .property IL directives.
	* get.c: allow passing a NULL as method in dis_stringify_method ()
	if a methoddef_row is given.
	
2001-08-20  Dietmar Maurer  <dietmar@ximian.com>

	* get.c (dis_stringify_type): support pinned values

Sat Aug 18 11:24:07 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dump.c, get.c, get.h, main.c: dis_stringify_method_signature()
	gets an optional methodef_row index instead of a name, so it
	can figure out also the names and attributes of params.
	parse_method_signature() and free_method_signature() removed as
	they are useless now.

2001-08-17  Dietmar Maurer  <dietmar@ximian.com>

	* main.c (pinvoke_info): bug fix - use the right column in the table

2001-08-14  Dietmar Maurer  <dietmar@ximian.com>

	* get.c (dis_stringify_type): use strconcat instead of strjoin

Sat Aug 4 12:36:54 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* get.c, get.h, main.c, dump.c: implement dis_stringify_method_signature().
	More magic constants replaced by enum values (spotted at least 3 real bugs
	doing this). Print usage information if an unknown option is given.
	Print the full signature when dumping the method table.
	Changed method and field table dumps to show the typedef name the field
	or method belongs to.

Fri Aug 3 18:30:16 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* get.c (get_method): fix use of unitialized variable and
	remove magic constants all over the place.

Wed Aug 1 22:46:45 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c: properly decode the switch opcode.
	
2001-08-01  Dietmar Maurer  <dietmar@ximian.com>

	* get.c (get_token): decode typedef and typeref tokens

	* main.c (dis_method_list): don't decode the next row, that is
	totally unnecessary

Tue Jul 31 17:48:11 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c, dis-cil.h, dump.c, dump.h, get.c, get.h, main.c, push-pop.h:
	massive namespace cleanup.
	* main.c: dis_locals() now just strigifies a MonoMethodHeader.

2001-07-31  Dietmar Maurer  <dietmar@ximian.com>

	* main.c (pinvoke_flags): impl.

Mon Jul 30 20:08:37 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c, dis-cil.h, main.c: changes to disassemble also
	the information about try/catch/finally blocks.

2001-07-27  Dietmar Maurer  <dietmar@ximian.com>

	* get.c (dis_stringify_type): return "void" if !type
	(dis_stringify_type): print type* instead of *type

Thu Jul 26 13:22:28 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c, dump.c, get.c, main.c: updates to match changes in metadata.
	Removed dead code.

2001-07-17  Miguel de Icaza  <miguel@ximian.com>

	* main.c (usage): Print out all the arguments.

	* get.c, main.c, dump.c: Remove `expand', `get_encoded_value',
	`get_blob_encoded_size' and replaced with the proper functions
	from metadata.c

2001-07-15  Miguel de Icaza  <miguel@ximian.com>

	* main.c (dis_code): Only display .entrypoint when we are dealing
	with a module that contains an entry point.  This removes a bunch
	of warnings for .dll dumping

Sun Jul 15 17:29:10 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* get.h,get.c: added some dis_stringify_object() functions:
	metadata decoding is now done in libmetadata. Still need to use
	them throughhout the code (and move other decode code to
	metadata). Fix also field decoding (band-aid until we load
	also referenced assemblies).
	* dis/main.c: start using the new routines.

2001-07-13  Miguel de Icaza  <miguel@ximian.com>

	* get.c (get_method): GOOD. Implemented this other bad boy.

2001-07-12  Miguel de Icaza  <miguel@ximian.com>

	* get.c (get_token_type): Implement TOKEN_TYPE_TYPE_SPEC.
	(get_typespec): Implement.
	(get_typedef_or_ref): Use get_typespec.

	* dis-cil.c (dissasemble_cil): Implement InlineField
	(dissasemble_cil): Implement InlineTok.

	* get.c (get_token, get_field): Implemented.  Worked around lame
	tables in the spec.

Wed Jul 11 18:52:15 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dis-cil.c: output real name of local var.
	* dump.c: output more info about fields (flags and type). Properly decode
	Property signatures. Decode also method table.
	* main.c: Fix local variable info. Hopefully fix field and property list.

Mon Jul  9 16:39:41 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dump.c: write stuff to output, not stderr. Give more info for properties.
	* dump.c,dump.h,main.c: implement dump_table_event(), dump_table_file(),
	dump_table_moduleref().
	* get.c: first attempt to decode string constants, need to find if and where
	this is actually specified.

Fri Jul  6 19:49:21 CEST 2001 Paolo Molaro <lupus@ximian.com>

	* dump.c,dump.h: implement dump_table_property().
	* main.c: implement local variable info disassembling.
	Annotate entrypoint method. Remove memory leak in 
	parse_method_signature ().

2001-07-04  Miguel de Icaza  <miguel@ximian.com>
	
	* get.c (get_methodref_signature): Implement.

	* dump.c (dump_table_memberref): Add memberref dumping.

Tue,  3 Jul 2001 18:32:10 +0200 Paolo Molaro <lupus@ximian.com>

	* main.c: return on failure.

2001-07-02  Miguel de Icaza  <miguel@ximian.com>

	* dis-cil.c (get_encoded_user_string): Return a string from the
	#US heap. o

	* get.c (get_blob_encoded_size): Implement 23.1.4 decoding.

2001-07-01  Miguel de Icaza  <miguel@ximian.com>

	* dis-cil.c: New file.  CIL opcode dissasembler.

2001-06-27  Miguel de Icaza  <miguel@ximian.com>

	* main.c: Split code.

2001-06-22  Miguel de Icaza  <miguel@ximian.com>

	* main.c: More work on the disassembler and on the understanding
	of the metadata file format.   

